/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.tables.records.VInputHelpparamRecord;

import java.util.Collection;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.Name;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class VInputHelpparam extends TableImpl<VInputHelpparamRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.v_input_helpparam</code>
     */
    public static final VInputHelpparam V_INPUT_HELPPARAM = new VInputHelpparam();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<VInputHelpparamRecord> getRecordType() {
        return VInputHelpparamRecord.class;
    }

    /**
     * The column <code>common_dd.v_input_helpparam.inputhelp</code>.
     */
    public final TableField<VInputHelpparamRecord, Integer> INPUTHELP = createField(DSL.name("inputhelp"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_input_helpparam.inputhelp_descr</code>.
     */
    public final TableField<VInputHelpparamRecord, String> INPUTHELP_DESCR = createField(DSL.name("inputhelp_descr"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_input_helpparam.param_order_nr</code>.
     */
    public final TableField<VInputHelpparamRecord, Integer> PARAM_ORDER_NR = createField(DSL.name("param_order_nr"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_input_helpparam.param_study</code>.
     */
    public final TableField<VInputHelpparamRecord, Integer> PARAM_STUDY = createField(DSL.name("param_study"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_input_helpparam.param_variable</code>.
     */
    public final TableField<VInputHelpparamRecord, Integer> PARAM_VARIABLE = createField(DSL.name("param_variable"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_input_helpparam.dn</code>.
     */
    public final TableField<VInputHelpparamRecord, String> DN = createField(DSL.name("dn"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_input_helpparam.needed_params</code>.
     */
    public final TableField<VInputHelpparamRecord, Integer> NEEDED_PARAMS = createField(DSL.name("needed_params"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_input_helpparam.stage</code>.
     */
    public final TableField<VInputHelpparamRecord, Integer> STAGE = createField(DSL.name("stage"), SQLDataType.INTEGER, this, "");

    private VInputHelpparam(Name alias, Table<VInputHelpparamRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private VInputHelpparam(Name alias, Table<VInputHelpparamRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.view("""
        create view "v_input_helpparam" as  SELECT t_input_help.inputhelp,
          t_input_help.inputhelp_descr,
          hp.order_nr AS param_order_nr,
          hp.fk_study AS param_study,
          hp.fk_variable AS param_variable,
          h.dn,
          t_input_help.needed_params,
          h.stage
         FROM ((common_dd.t_input_help
           LEFT JOIN common_dd.t_input_helpparam hp ON ((hp.fk_inputhelp = t_input_help.inputhelp)))
           LEFT JOIN common_dd.t_core_element_hierarchy h ON ((hp.fk_variable = h.key_element)))
        ORDER BY hp.fk_study, t_input_help.inputhelp, hp.order_nr;
        """), where);
    }

    /**
     * Create an aliased <code>common_dd.v_input_helpparam</code> table
     * reference
     */
    public VInputHelpparam(String alias) {
        this(DSL.name(alias), V_INPUT_HELPPARAM);
    }

    /**
     * Create an aliased <code>common_dd.v_input_helpparam</code> table
     * reference
     */
    public VInputHelpparam(Name alias) {
        this(alias, V_INPUT_HELPPARAM);
    }

    /**
     * Create a <code>common_dd.v_input_helpparam</code> table reference
     */
    public VInputHelpparam() {
        this(DSL.name("v_input_helpparam"), null);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public VInputHelpparam as(String alias) {
        return new VInputHelpparam(DSL.name(alias), this);
    }

    @Override
    public VInputHelpparam as(Name alias) {
        return new VInputHelpparam(alias, this);
    }

    @Override
    public VInputHelpparam as(Table<?> alias) {
        return new VInputHelpparam(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public VInputHelpparam rename(String name) {
        return new VInputHelpparam(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public VInputHelpparam rename(Name name) {
        return new VInputHelpparam(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public VInputHelpparam rename(Table<?> name) {
        return new VInputHelpparam(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VInputHelpparam where(Condition condition) {
        return new VInputHelpparam(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VInputHelpparam where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VInputHelpparam where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VInputHelpparam where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VInputHelpparam where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VInputHelpparam where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VInputHelpparam where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VInputHelpparam where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VInputHelpparam whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VInputHelpparam whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
